#include <omnetpp.h>
#include "test2.h"
#include "glNaglowek.h"
#include "SingleLink.h"
#include "SBVTnode.h"
#include "PathSD.h"
#include "CyclePath.h"
#include "Block.h"
#include "BlockSet.h"
#include "NetUsage2.h"

using namespace std;

class Net: public cSimpleModule {

    //-----statystyki--//

    long nDemandSlot; //zadana wielkosc bandwidth
    long nBlockedSlot; //iloc zablokowanych bandwidth
    long nAckSlot; //potwierdzona liczba zadan bandwidth

    //kasuj  long util_1; //zajetosc po odpowiedzi optycznej sieci na zadanie mozliwe albo ack, lub nack
    long util_eon; //zajetosc sieci co 1000 zadan
    long util_ipLink; //zajetosc laczy Ip co 1000 zadan
    long util_sbvt; // zajetosc bvts co 1000 zadan
    long numDBypass; //liczba zadan obsluzonych przez bypassy bajpassow
    long bwBypass; // bandwidth obsluzonych przez bypassy
    long nbwBypass;

    long nHopsIP; //liczba hopow zadania w warstwie IP
    long pathLenEon; //zlicza dlugosci sciezek przyjetych zadan w eon

    int nBypass; //liczba zestawianych bypassow
    int numD; //zlicza przybylych zadania do sieci
    int numD2;
    int numAck; //liczba wyslanych ack //bylo long numAck
    int numNack; //liczba wyslanych nack;//bylo long

    double numBlockedBypass; //liczba zadan kiedy eon nie przyjal i zwrocil do ip, ktora przxyjela zadanie
    double bwBlockedBypass;

//---------zmienne- parametry sieci-----//
    int m_nslots; //ilosc slotow
    int m_nNodes;
    int m_nLinks;
    int m_nCand; //wszystkie sciezki zapisane w  pliku
    int m_cand; //??  liczba analizowanych sciezek
int m_nIPpaths;//liczba rozpatrywanych cieżek w IP


    double m_bitrate; //max bit rate lacza IP

    double m_thereshold; //prog powyzej ktorej wystepuje przeciazenie na laczu IP
    //double m_nSlotsForIP;//liczba slotĂłw dla IP

    double m_smallSizeReq;
    //double m_mediumSizeReq;
    double m_bigSizeReq;

    double m_capacitySBVT;
    double m_granularitySBVT;
    int m_nSBVT;

    double m_grid;
    int m_nguard;



    vector<int> m_links; //wektor dlugosi w km linkow
    vector<double> m_degNodes; //wektor stopnia wezla
    //vector<vector<int> > m_topology; //topologia sieci

    vector<SingleLink> m_vecLinks; //wektor Laczy / polaczen miedzy wezlami

    vector<SBVTnode> m_sbvtsIn;
    vector<SBVTnode> m_sbvtsOut;

    vector<vector<vector<PathSD> > > m_connection; //pathMgr
    vector<vector<CyclePath> > m_currIdx; //wektor przechowujacy indeks cyklicznej sciezki

    NetUsage2 matrix1; //przechowuje stan wykorzystania laczy optycznych
    //NetUsage2 *mm;
    ofstream outfile, outfile2;

    //-----metody do ustawien  initialize---//
    vector<int> loadLengthLinksFromFile(string filename, int nodes, int links); //laduje dlugosci laczy z pliku
    vector<double> loadDegreeNodeFromFile(string filename, int nodes, int links); //laduje wektor stopnia wezlow
    //vector<vector<int> > loadTopologyFromFile(string filename, int nodes, int links); //topologia sieci wczytana z pliku

    vector<SingleLink> loadLinksFromFile(string filename, int nodes, int links,  double maxtraffic, double thereshold);

    vector<SBVTnode> setSBVTmgr(vector<double> vecdegree, int nodes, double capacity, double granularity, int number);

    vector<vector<vector<PathSD> > > setFromFile(string filename, int node, int link, int can); //ustawia path Mgr z pliku

    vector<vector<vector<PathSD> > > setRegFromFile(string filename, int node, int link, int can); //ustawienie regeneracji

    vector<vector<CyclePath> > setCyclic(int nodes, int cand);
    void setIPtraffic(double load);

    void setCand(int can); //ustawienie mniejszej liczby candydatow
    int numCand();
//--------------------------------------------//
    void showVecSingleLink();
    void showSBVTs();
    void checkPaths();
//---------------------------------------------//
    vector<PathSD> candPaths(int src, int dest); //??pierwszych n-kandydujacych sciezek dla zadania, ale ja juz ucinam przy wczytywaniu
//---do obliczen statystyk path dla alg. path choice----//
    int calcHop(vector<bool> pathAlloc);
    int calcLen(vector<bool> pathAlloc);

    //--!! pobieranie zajetosci do statystyk--////
    double utilSBVTs(); //wykorzystanie sbvt
    double utilIP(); //wykorzystanie aczy IP
    double numberBlockedBypass(); //liczba zadan dla ktorych wystapila blokada optyki
    void set_blockedBypassParameters(double val); //ustawia wartosc comgNoBypass i bwBlockedBypass
    double getBwBlockedBypass();

//-------wyswietlanie----------//
    void show(int src, int dest);
    void showVector(vector<int> myVec);
    void showMap(multimap<int, int> map);
    void toOutfile();

    bool ipEon_allocated(int src, int dest, double bw, int id); //czy istnieja zasoby w sieci obojetnie w jakiej warstwie
    int ipFirst_transmit(int src, int dest, double bw, int id);//
    int ipFirst_transmit_MSFffsa(int src, int dest, double bw, int id); //w pierwszej kolejnoĹ›ci IP w eon alokacja na sciezce MSF i FFSA
    int ipFirst_transmit_modifMSFffsa(int src, int dest, double bw, int id); //w pierwszej kolejnoĹ›ci IP w eon alokacja na sciezce modifMSF i FFSA
     bool ipEon_allocatedQAM(int src, int dest, double bw, int id);//sprawdza zasoby z uwzgk alokacji na QAM
    int ipFirst_transmitQAM(int src, int dest, double bw, int id);//alokacja optyczna tylko na modulacjach >2 czyli QAm

    bool ipEon_terminate(int src, int dest, double bw, int id, int bypass); //konczu transmisje w ip lub eon
    int eonFirst_transmit(int src, int dest, double bw, int id); //najpierw alokuje w eon
    int sizeFirst_transmit(int src, int dest, double bw, int id);
//z uwzglednieniem ruchu backgroud
    bool singleEON_allocatedBack(int src, int dest, double bw,int id, int tmp);// ruch background i wszystko do eon
    int eonIp_transmitBack(int src, int dest, double bw, int id, int tmp); // ruch backgroud do ip reszta  do eonu jak da rade
    bool ipEon_allocatedBack(int src, int dest, double bw, int id, int tmp); //z uwzglednieniem ruchu backgroud
    bool multiIpEon_terminate(int src, int dest, double bw, int id, int bypass);
  bool   disconnectIP(double bw,int id);
    bool findResources(int src, int dest, double bw, int id);
    bool findResources2(int src, int dest, double bw, int id); //??
    int transmit(int src, int dest, double bw, int id); //zwraca liczbe ustawionych bypass

    int terminateFlow(int src, int dest, double bw, int id); // ok!! zwraca liczbe usunietych bypassow

    //--PLIK vec_singleLink--//
    bool congestedIPlinks(int src, int dest); //true gdy chociaďż˝by 1 z laczy jest przeciazone na odcinku pomiedzy src i dest
    bool enoughtIPlinks(int src, int dest, double bw); //true gdy odcinek laczy pomiedzy src dest moďż˝e przujac zadanie//czyli wszystkie lacza na odcinku spelniaj przyjecie ďż˝adania, nie jest sprawdzane przeciaznie ich
    void allocIP(int src, int dest, double bw, int id); //OK  terminateFlowId(double rate,int id)

    bool terminateIPflow(int src, int dest, double bw, int id); //OK zakonczenie transmisji na laczach ip
    bool allocatedLinkIdx(int idx, double bw);
    //---//
    bool end_to_end_allocated(int src, int dest, double bw, int id); //OK
    int end_to_end_transmit(int src, int dest, double bw, int id); //ok
    bool end_to_end_terminate(int src, int dest, double bw, int id, int bypass); //ok

    bool link_by_link_allocated(int src, int dest, double bw, int id);
    int link_by_link_trasnmit(int src, int dest, double bw, int id);
    bool link_by_link_terminate(int src, int dest, double bw, int id,
            int bypass);

    //plik sbvts.cc---//
    bool enougthSBVT(int nodeIn, int nodeOut, double bw);
    void addTransmissionToSBVT(int nodeIn, int nodeOut, double bw, int id);
    void releaseTransmissionSBVT(int nodeIn, int nodeOut, double bw, int id);

    bool possibleBypass(int nodeIn, int nodeOut, double bw, int id);
    //bool multiBypass(int src, int dest,double bw, int id);
//------------------//

    //--------multi Path w IP----------//
    bool enoughtIPpaths(int src, int dest, double bw);
    bool ipPathsEon_allocated(int src, int dest, double bw,int id); //sprawdza czy alokowalne IP lub alokowalny bypass
    int ip_idxPathAllocated(int src, int dest, double bw, int id);//zwraca -1 gdy brak sciezki, lub indeks pierwszej sciezki IP gdzie istnieją zasoby
    bool ip_candPathAllocated(int src, int dest, double bw, int id, int ncandIP); //czy kandydująca scieżka jest alokowalna
    int ip_idxAllocatedNotCongested(int src, int dest, double bw, int id);
    int ipPathsFirst_transmit(int src, int dest, double bw, int id);
    bool congested_candIPpath(int src, int dest, int candIP);//gdy nieprz
    bool existNotCongestedIPpaths(int src, int dest);
    void allocIPpaths(int ncand,int src,int dest,double bw, int id);
    int multiIPpEon_allocatedBack(int src, int dest, double bw,int id, int tmp);
    void multiIP_allocBack(int src, int dest, double bw,int id);
    int ipPathsFirstSBVT_transmit(int src, int dest, double bw, int id);//kilka sciezekw IP i SBVT
      bool ipEonSBVT_terminate(int src, int dest, double bw, int id, int bypass);
    virtual void initialize();
    virtual void handleMessage(cMessage *);
    virtual void finish();

};

Define_Module(Net)
;
