#ifndef _NETUSAGE2_H_
#define _NETUSAGE2_H_
#include "glNaglowek.h"
#include "PathSD.h"
#include "Block.h"
#include "BlockSet.h"
#include "SetMgr.h"
#include "BlockMgr.h"
#include "FitGap.h"



using namespace std;

//jesli funkcja( vector<bool> path, int liczba wymaganych slotow)
//jesli funkcja( PathSD, double bandwidth) i bandwidth przeliczamy na liczbe slotow //POPRAWIC
class NetUsage2
{
public:

double m_netUtil; // wykorzystania zasobow sieci suma zajetosci slotow laczy, aktualizacja w alloc oraz disconnectId
int m_idxPathAlloc; //przechowuje indeks sciezki ostaniej alokacji
vector<vector<int> > m_netUsage; //tablica zajetosci slotow linkow
vector<double> m_linkRate;

vector<bool> m_pathAlloc;//przechowuje wektor sciezki alokowanego zadania
int m_hopAlloc; //zmienna do przechowywania liczby skoków alokowanego polaczenia
int m_specAlloc; // z każdym zestawionym polaczeniem dodawana jest jego ilosc wykorzystanych zasobow
double m_specEf; //spectral efficiency po zczytaniu wyniku jest zerowany parametr
long  m_tab[4]; //tablica przechowuje ilosc użyc każdej z modulacji przez polaczenia
long m_tab2[4];//tablica przechowuje ilosc slotow wykorzytsanych przez modulacje wlacznie z GB

int m_nlinks;
int m_nslots;
 int m_ls; //iloczyn link i slot
double m_grid;
int m_GB;
BlockSet *fs;

Block *bl;

BlockMgr *mgr;//zarzadzanie blokami scie���ki

SetMgr *sm; //zarzadzanie zbiorami blokow, wybor sciezki
FitGap *gap; //dopasowanie gap head/tail


NetUsage2();
NetUsage2(int nlinks, int nslots, double grid, int guard_band);
void fillZeros(int nlinks, int nslots, double grid, int guard_band); //wypelnienie zerami tablicy oraz wskaznik m_netUtili=0 oraz m_idxPathAlloc=-1
double getNetUtil(); //zwraca aktualna wartosc netUtili
int getIdxPathAlloc(); //indeks sciezki ostatniej alokacji
vector<bool> getVecPathAlloc();
void clearPath();
int hopAlloc(); // zwrac liczbe skokow sciezki przyjetego zgloszenia i zeruje m_hopAlloc
double getSpecEf();//zwraca wsp��lczynnik
int getSpecAlloc();//zwraca zajete zasoby przez przez zestawiane polaczenia
void setZeroEf(); //ustaw wspolczynnik spectrum na zero i wspolczynnik m_specAlloc
long getTab(int i); //zwraca wartosc dla danej modulacji podanej w indeksie
long getTab2(int i);


//obsluga polaczen//
//-----------------------------------------------------------------------------------------------------//
bool disconnectId(int id);
void alloc(vector<bool> pathSD, int resources, int startIdx, int id);
int checkFree( vector<bool> pathSD, int resources); //zwaraca znaleziony pierwszy  indeks na danej sciezce wolnych zasobow
bool existFreeForReq(vector<bool> pathSD, int numReq);
int checkOpticalNet(vector<PathSD> canPaths, double bw, int id);
void spfff_flow_alloc(vector<PathSD> canPaths, double bw, int id);
int checkOpticalNetQAM(vector<PathSD> canPaths, double bw, int id); //sprawdza laokacje na sciezkach do modulacji QAM czyli wieksze od 2
void modifMSFffsa_flow_alloc(vector<PathSD> canPaths, double bw, int id);//alokacja na sciezce modif MSF
void msf_ffsa_flow_alloc(vector<PathSD> canPaths, double resources, int id);//alokacja na sciezce MSF

//-----------------------------------------------------------------------------------------------------//


//sprawdz czy udala sie alokacja i wyslac ack czy nack
bool checkAllocPath(PathSD path, double bw, int id);    //sprawdz zasoby jednej sciezki, obiektu path klasy PathSD //np. podanej cykliczne

//--obliczenia BlockSet//
void setFreeForReq(vector<bool> pathSD, int numReq); // ustawienie BlockSet z modulacia 0; dla spektrum sciezki, do analizy pierwszej wolnej sciezki

//-------kombinacje R+FF---------------------------//

bool firstPathFirstFitSlot(vector<PathSD> canPaths, double bw, int id);
int firstFitSlot(vector<bool> pathSD,int numReq);
bool msf_ffsa(vector<PathSD> canPaths, double resources, int id); //most slot first  + first fit slot allocation
bool modif_msf_ffsa(vector<PathSD> canPaths, double resources, int id);
int pathIdx(vector<PathSD> canPaths, double resources, int id);
bool lsoHop_ffsa(vector<PathSD> canPaths, double resources, int id);
bool modif_lsoHop_ffsa(vector<PathSD> canPaths, double resources, int id);



//------alg best blok----------------------------------//
bool firstPathBestFitSlot(vector<PathSD> canPaths, int resources, int id); //na pierwszej znalezionej sciezce dobieram block najlepiej pasujacy
bool firstPathBestEdge(vector<PathSD> canPaths, int resources, int id); // start w pierwszym bloku best na podstawie edge
bool firstPathBestUsage(vector<PathSD> canPaths, int resources, int id) ;//start w pierwszym best bloku na podstawie usage

int bestFitSlot(vector<bool> pathSD, int numReq); //zwraca indeks do smallest size block  obszaru//gdy brak zasobow to m_nslots
//---ALG--MAXUSAGE---------------------//
//bool firstPath_mySA(vector<PathSD> canPaths, double resources, int id); //sciezka pierwsza znaleziona, alokacja w bloku max usage , niekoniecznie bestfit
//int maxUsageBlockReq(vector<bool> pathSD, int numReq);//zwracam indeks lewy bloku wolnych slotow maxUsage dla danej sciezki
////--------------------------//
//bool firstPathHeadFitSlot(vector<PathSD> canPaths, int resources, int id);//dla pierwszej wolnej sciezki wybIeramy taki blok dla zadania , dla a ktorego HEAD jest najmniejszy dopasowanie na l���czachc //troche bezsensu
//int headFitSlot(vector<bool> pathSD, int numReq); //zwaraca indeks start dla head najlpszego dopasowania na ������czach
//////----dopasowanie glowy i ogona dla numReq--//
//bool firstPathHeadTailReq(vector<PathSD> canPaths, int resources, int id);
//int headTailStart(vector<bool> pathSD, int numReq); //zwraca indeks dla najlepszej dopasowania numReq na laczach sprawdzajac od start req , start+numReq
////----------najlepiej dopasowany wolny blok spectrum ------------------//
//bool firstPathBlockFit(vector<PathSD> canPaths, int resources, int id);
//int blockFitStart(vector<bool> pathSD, int numReq); // sprawdzane dopasowanie calego wolnego bloku, przyda sie dla groomingu


////--katalog alg_topBlock--//
//bool fpfuTop(vector<PathSD> canPaths, int resources, int id);//first path, min free, max usage dla alokacji top w bloku
//
//int ideaGap(vector<bool> pathSD, int numReq); //gdy brak size=numRq to ustawiam fit gap
//
//////--alg_bestFirst-- sizeBest=numReq lub gap--//
////bool firstPathMaxUsageLRside(vector<PathSD> canPaths, int resources, int id); // best=numReq lub gap minFree MaxUsage idx
//bool firstPathEdgeFit(vector<PathSD> canPaths, int resources, int id); //dopasowanie best=numReq lub gap

////--obliczenia FitGap--//
//void setFitGaps(vector<bool> pathSD, int numReq,int modul);
//
//////Ustawienia zawsze Gapow --//
////int maxUsageLRside( vector<bool> pathSD, int numReq,int modul); //dla sciezki szukanie max usage dla left i right gap
////bool firstPathEdgeGap(vector<PathSD> canPaths, int resources, int id);//wq
//
//////ALGORYTM DOPASOWANIA KONCOW ZADANIA DO LINKOW -//
////??czy ma sens edgeFit??//
//int edgeFit(vector<bool> pathSD,int numReq,int modul);//zwraca max liczbe slot���w lub indeks startu do bloku <start, numReq> najlepiej wpasowanego na karncach
//////---plik start_inBlock_dotyczy juz dla sicezki o wolnych zasobach alokacj-//
////int startInFirstBlock(vector<bool> pathSD,int numReq);
//
//int startInBestEdge(vector<bool> pathSD,int numReq);
//int startInBestUsage(vector<bool> pathSD,int numReq);
//int startInBlock(vector<bool> pathSD,int startB, int sizeB, int numReq);
//----------------------------------//

        //--obliczenia SetMgr--//
void setSetCand(vector<PathSD> canPaths, int resources, int id);//ustawienie wektora blockSet dla kazdej ze sciezek

bool fragmPath(vector<PathSD> canPaths, int resources, int id);//+ first fit alokacja na najbardziej podziurowanej sciezce

bool avSizePath(vector<PathSD> canPaths, int resources, int id);//+best fit//alokacja na sciezke o najmniejszej srednim rozmiarze dziur
bool avReqSizePath(vector<PathSD> canPaths, int resources, int id);//+bestFit//alokacja na sciezke o najmniejszej sredniej rozmiarow dziur mogacych oblsuzyc zadanie

bool betterBlockPath(vector<PathSD> canPath, int resources, int id);//+best fit alokacja na sciezce, ktora ma blok zblizony wielkoscia do zadania

bool worstUtilizeLP(vector<PathSD> canPaths, int resources, int id); //+sposr���d sciezek wybierana jest ta o najgorszym wykorzystaniu i tam alokujemy zadanie w bloku bestFit


//model referencyjny path selection policy
//bool msf_mySa(vector<PathSD> canPaths, int resources, int id);//most slot first +my slot allocation
//bool modif_msf_mySA(vector<PathSD> canPaths, int resources, int id); //modified most slot first + my slot allocation
//
//bool msf_bfsa(vector<PathSD> canPaths, int resources, int id) ;//most slot first +best fit slot allocation
//
//bool meanSizePath (vector<PathSD> canPaths, int resources, int id);//best fit
//bool meanSizeReqPath(vector<PathSD> canPaths, int resources, int id);//best fit

//----obliczenia BlockMgr------------------------------------//
bool usageBlockCand(vector<PathSD> canPaths, int resources, int id);

//-- idxfirstPath---//
int freePathIdx(vector<PathSD> canPaths, int resources, int id);

//--obliczenia MiniGap--//
//void setMiniCand(vector<PathSD> canPaths, int resources, int pathIdx,int id);//ustawienie mini dla kandydujacych sciezki
//void setMiniPath(vector<bool> path, int numReq,  int modul);//ustawienie dla sciezki mini
//bool enoughMini(vector<bool> path, int numReq, int modul,int numGap, int sumGap);
//bool miniGapFirst(vector<PathSD> canPaths, int resources, int id);//w pierwszej kolejnosci sprawdzaj czy sa mini, w kt���re mo���na alokowac zadanie
//
//int searchFreeSlot(vector<bool> pathSD, int numReq);//zwraca pierwszy znaleziony idx, lub liczbe slot���w
//zastanowic sie nad tym czy ma wplyw aklokacja lewy prawy, obliczenia dla calego wolnego bloku, slotow tylko zajmowanych przez zadanie//




//---obliczenia dla lightpath czyli spektrum sciezki--------------------------//
double maxIdxLP(vector<bool> pathSD);//indeks ostatni zajety,
double numUsedLP (vector<bool> pathSD); //ilosc zajetych slotow LP
double numFreeLP(vector<bool> pathSD);//ilosc wolnych slotow LP
double utilizeLP(vector<bool> pathSD);//wykorzystanie sciezki


//--------------------------------------------------//
void setElement(int i , int j, int val);
int getElement(int i , int j);
vector <int> getSumFiberSD( vector<bool> pathSD);
vector<vector<int> > get_pathLinksUsage ( vector<bool> pathSD);//pobierz kolumny,o indeksach wskazanych przez pathSD

vector<int> row(int idx);
vector<vector<int> > getRows(int startIdx, int numS);//pobierz wiersze od start idx w ilosci numS

vector<int> getColumn(int j);
int sumRows(int col);//sumuj wszystkie wiersze dla danej kolumny

bool freeFiber(int col) ;//czy same zera ma kolumna


//---??obliczenia niedopasowania -na kolumnach--//
int decideLRStart(vector<bool> pathSD,int numReq, int start, int sizeBlock); //na podstawie niedopasowania na ������czach

////potrzebne do firstPathEdgeFit ;
//int calcHeadFit(vector< bool> pathSD, int startIdx);//suma count to start
//int countToStart( int startIdx, int col);//obliczenie niedopasowania dkla startu na pojedynczym laczu
//int calcTailFit(vector<bool> pathSD, int startIdx, int sizeBlock);
//int countFromEnd(int startIdx, int sizeBlock, int col); //dla best fit sizeBlock==numReq

//---obliczenia na wierszach/spektrum slotow----//
bool unuseSlot(int idx);//czy same zera w danym wierszu
int countFreeSlotInNet();// liczba calkowicie wolnych slotow w sieci //OK
double usageSlotPerLink(int idx); // zajetosc danego slotu na laczach, //przez calkowita sume laczy //czyli nie -1!!
double usageBlockPerLink(int start, int numS);// do porownania roznych start slot blokow alokacji
int cFreeSlotInBlock(int start, int numS);// liczba wolnych slotow w danym bloku slotow na wszystkich ������czach

void showMatrix() const;



virtual ~NetUsage2();


};
#endif







