#include "NetUsage2.h"

int NetUsage2::pathIdx(vector<PathSD> canPaths, double resources, int id)
{

    int idxPath=-1;

    for (int i=0; i<canPaths.size(); ++i)
    {
        double resources2=resources/m_grid;
        int numReq = (int) ceil(resources2/canPaths[i].getModul()) + m_GB;
        if (existFreeForReq(canPaths[i].getVec(), numReq)==true )

        {
            idxPath=i;
            //cout<<" sa zasoby od idxPath"<< i<< endl;
            break;
        }
    }

return idxPath;
}


bool NetUsage2::msf_ffsa(vector<PathSD> canPaths, double resources, int id) {
// wybor sciezki most-Slot-First i first fit spectrum allocation
    fs = new BlockSet;
    sm = new SetMgr;
    int idx = pathIdx(canPaths, resources, id);
    if (idx == -1) {
        return false;
    }
    if (idx>=0)
    {
        for (int i = idx; i < canPaths.size(); ++i)
        {
           double resources2=resources/m_grid;
           int numReq = (int) ceil(resources2/canPaths[i].getModul()) + m_GB;
            if ( existFreeForReq(canPaths[i].getVec(), numReq) == true)
            {

                fs->  makeBlockSet(canPaths[i].getVec(),numReq, getSumFiberSD(canPaths[i].getVec()),canPaths[i].getModul());
                sm->addSet(*fs);
            }
        }
        vector<bool> worstPath = sm->worstPath();
        m_pathAlloc=worstPath;
        int modulW=sm->getModulWorstPath();
        double resourcesW=resources/m_grid;
        int numReqWorst = (int) ceil(resourcesW/modulW) + m_GB;

        int startIdx= checkFree(worstPath, numReqWorst );//alg first fit

        alloc(worstPath, numReqWorst, startIdx, id);

        return true;
    }
}




bool NetUsage2::modif_msf_ffsa(vector<PathSD> canPaths, double resources, int id)
//wybor sciezki  modyfikacja most-Slot-First
 {
        int idx = pathIdx(canPaths, resources, id);
    if (idx == -1) {
        return false;
    }

    fs = new BlockSet;
    sm = new SetMgr;

    if (idx>=0)
    {
        int modul = canPaths[idx].getModul();
        int hop = canPaths[idx].getHops();
        double resources2=resources/m_grid;
        int numReq = (int) ceil(resources2/canPaths[idx].getModul()) + m_GB;
        for (int i = idx; i < canPaths.size(); ++i)
        {
            if (modul != canPaths[i].getModul())
            {
                //cout << "moduacja wieksz " << canPaths[i].getModul() << endl;
                break;
            }
            if (modul == canPaths[i].getModul() && existFreeForReq(canPaths[i].getVec(), numReq) == true )
            {

                fs->  makeBlockSet(canPaths[i].getVec(),numReq, getSumFiberSD(canPaths[i].getVec()),modul);
                //fs->displaySet();
                sm->addSet(*fs);
            }
        }
        vector<bool> worstPath = sm->worstPath();
        m_pathAlloc=worstPath;
        //int startIdx= checkFree(worstPath, numReqWorst );//alg first fit
               //alloc(worstPath, numReq, startIdx, id);
          alloc(worstPath, numReq, checkFree(worstPath, numReq), id);

        return true;
    }
}

/*bool NetUsage2::msf_exactFit(vector<PathSD> canPaths, double resources, int id) {
// wybor sciezki most-Slot-First i exact fitfit spectrum allocation
    fs = new BlockSet;
    sm = new SetMgr;
    int idx = pathIdx(canPaths, resources, id);
    if (idx == -1) {
        return false;
    }
    if (idx>=0)
    {
        for (int i = idx; i < canPaths.size(); ++i)
        {
           double resources2=resources/12.5;
           int numReq = (int) ceil(resources2/canPaths[i].getModul()) + 1;
            if ( existFreeForReq(canPaths[i].getVec(), numReq) == true)
            {

                fs->  makeBlockSet(canPaths[i].getVec(),numReq, getSumFiberSD(canPaths[i].getVec()),canPaths[i].getModul());
                sm->addSet(*fs);
            }
        }
        vector<bool> worstPath = sm->worstPath();
        m_pathAlloc=worstPath;
        int modulW=sm->getModulWorstPath();
        double resourcesW=resources/12.5;
        int numReqWorst = (int) ceil(resourcesW/modulW) + 1;

        int startIdx = exactFit(worstPath, numReqWorst); //exact fit sa
        alloc(worstPath, numReqWorst, startIdx, id);

        return true;
    }
}*/
