#include "Net.h"

using namespace std;
//ponizej metody zwizane  z wektorem SlingleLink

vector<SingleLink> Net::loadLinksFromFile(string filename, int nodes, int links, double maxtraffic,double thereshold)
{
  vector<SingleLink> tmpLinks;
       vector<vector<int> > topology;

       ifstream infile(filename.c_str());
       if (infile.is_open() == false) {
           cerr << "Error: Unable to read the specified network structure file."
                   << endl;
           exit(1);
       }

       topology.resize(nodes);

       for (int i = 0; i < nodes; ++i) {
           topology[i].resize(nodes);

           for (int j = 0; j < nodes; ++j) {

               if (infile.eof() == true) {
                   cerr << "Error: Insufficient number of coefficients." << endl;
                   exit(1);
               }
               infile >> topology[i][j];
           }
       }
       infile.close();

       for (int i = 0; i < nodes; ++i) {
           for (int j = 0; j < nodes; ++j) {
               if (topology[i][j] > 0) {
                   SingleLink l1;
                   l1.setLink(i,j,topology[i][j],maxtraffic,thereshold);
                   tmpLinks.push_back(l1);             //m_vecLinks.push_back(l1);
               }
           }
       }

    return tmpLinks;
}

//---//
void Net::setIPtraffic(double load)
{
    for (int i=0; i<m_vecLinks.size(); ++i)
                {
        m_vecLinks[i].setLoad(load);
                }

}

void Net::showVecSingleLink()
{
    for (int i=0; i<m_vecLinks.size(); ++i)
            {
          cout<< "nr: "<< i << " traffic";
          m_vecLinks[i].showTraffic();
          // m_vecLinks[i].showFlows();
            }
    }

double Net::utilIP()
{
   double  ret=0;
    for (int i=0; i<m_vecLinks.size(); ++i)
            {

          ret = ret + m_vecLinks[i].getActualTraffic();
//cout<<"ruch IP na laczu: "<< i<< " wynosi " << m_vecLinks[i].getActualTraffic()<<endl;
            }
    //cout<< "sumaryczna wielkosc: "<< ret<<endl;
    return ret;
    }

bool Net::congestedIPlinks(int src, int dest)//gdy nieprzeciazone to true
{

    int ret=0;
    vector<bool> path = m_connection[src][dest][0].getVec();
       for (int i = 0; i < m_vecLinks.size(); ++i)
       {
            if (path[i] == 1  && m_vecLinks[i].congested() ==true) //jest przeciazone
               {
                //cout<<"przeciazone lacze o nr idx=: "<<i<<" i traffic=: " <<m_vecLinks[i].getActualTraffic() <<" "<< endl;
return true;
                               }

           }
return false;
}

//--------------

//bool Net::enoughtIPlinks(int src, int dest, double bw, int id){
bool Net::enoughtIPlinks(int src, int dest, double bw){
int ret=0;
    vector<bool> path = m_connection[src][dest][0].getVec();
    for (int i = 0; i < m_nLinks; ++i) {
               if (path[i] == 1 && m_vecLinks[i].allocatedIPLink(bw) == false)
               {
                   return false;
                              }
    }
    return true;
}

void Net::allocIP(int src,int dest,double bw, int id)
{
    vector<bool> path = m_connection[src][dest][0].getVec();
        for (int i = 0; i < m_nLinks; ++i)
        {
         if (path[i] == 1 && m_vecLinks[i].allocatedIPLink(bw)== true)
           {
             nHopsIP=nHopsIP+1; //zliczenie nHopsIP;
//cout<< "lacze ip przed alokacja o  idx=: "<< i<< "o m_alltraffic=: "<< m_vecLinks[i].getActualTraffic()<<endl;
               m_vecLinks[i].addFlow(bw,id);
               //cout<< "lacze ip po alokacji o  idx=: "<< i<< " o m_alltraffic=: "<< m_vecLinks[i].getActualTraffic()<<endl;
           }
         else if (path[i] == 1 && m_vecLinks[i].allocatedIPLink(bw) == false)
         {
             cout<< "link i = "<< i<< " traffic " <<m_vecLinks[i].getActualTraffic()<<endl;
               cerr<< "alokacja - zasoby IP powinny byc a nie ma "<<endl;
                           exit (1);
           }
}
}


//---------------//

bool Net::allocatedLinkIdx(int idx, double bw)
{

                {
                        return m_vecLinks[idx].allocatedIPLink(bw);
                }
}



bool Net:: disconnectIP(double bw,int id)
{
  int ret=-1;
    for (int i = 0; i < m_nLinks; ++i)
         {
          if ( m_vecLinks[i].existFlow(id)== true)
            {
              m_vecLinks[i].removeFlow(bw, id);
            }
          ret=1;
 }
    if (ret==-1)
    { cerr<< "disconnetIP blad"<<endl;
    exit (1);}
    else
        {return true;}
 }


